%global with_doc %{!?_without_doc:1}%{?_without_doc:0}
%global release_name kilo
%global service magnum
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

Name:		openstack-magnum
Summary:	OpenStack Orchestration (magnum)
Version:	2015.1.0
Release:	2%{?milestone}%{?dist}
License:	ASL 2.0
Group:		System Environment/Base
URL:		http://www.openstack.org

Provides:	magnum

Source0:	http://launchpad.net/%{service}/%{release_name}/%{version}/+download/%{service}-%{upstream_version}.tar.gz

Source1:	magnum.logrotate
%if 0%{?rhel} && 0%{?rhel} <= 6
Source2:	openstack-magnum-api.init
Source3:	openstack-magnum-conductor.init
%else
Source2:	openstack-magnum-api.service
Source3:	openstack-magnum-conductor.service
%endif
Source20:	magnum-dist.conf
Source21:	magnum.conf.sample

Patch1:		0001-Remove-docker-volume-support.patch
Patch2:		0001-Update-rc-manifest-parsing-according-to-v1beta3.patch
Patch3:		0008-Configure-minions-properly.patch
Patch4:		0001-Update-service-manifest-parsing-according-to-v1beta3.patch
Patch5:		0010-Update-quickstart-guide-to-v1beta3-manifests.patch


BuildArch: noarch
BuildRequires: git
BuildRequires: python2-devel
BuildRequires: python-setuptools
BuildRequires: python-sphinx
BuildRequires: python-oslo-sphinx

%if ! (0%{?rhel} && 0%{?rhel} <= 6)
BuildRequires: systemd-units
%endif

Requires: %{name}-common = %{version}-%{release}
Requires: %{name}-conductor = %{version}-%{release}
Requires: %{name}-api = %{version}-%{release}

%prep
%setup -q -n magnum-%{upstream_version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
rm -rf {test-,}requirements.txt tools/{pip,test}-requires

cp %{SOURCE21} etc/magnum/magnum.conf.sample

%build
%{__python} setup.py build


%install
%{__python} setup.py install -O1 --skip-build --root=%{buildroot}
mkdir -p %{buildroot}/var/log/magnum/
mkdir -p %{buildroot}/var/run/magnum/
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-magnum

%if 0%{?rhel} && 0%{?rhel} <= 6
# install init scripts
install -p -D -m 755 %{SOURCE2} %{buildroot}%{_initrddir}/openstack-magnum-api
install -p -D -m 755 %{SOURCE3} %{buildroot}%{_initrddir}/openstack-magnum-conductor
%else
# install systemd unit files
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_unitdir}/openstack-magnum-api.service
install -p -D -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/openstack-magnum-conductor.service
%endif

mkdir -p %{buildroot}/var/lib/magnum/
mkdir -p %{buildroot}/etc/magnum/

%if 0%{?with_doc}
export PYTHONPATH="$( pwd ):$PYTHONPATH"
pushd doc
#sphinx-build -b html -d build/doctrees source build/html

popd
%endif

rm -f %{buildroot}/%{_bindir}/magnum-db-setup
rm -rf %{buildroot}/var/lib/magnum/.dummy
rm -f %{buildroot}/usr/bin/cinder-keystone-setup
rm -rf %{buildroot}/%{python_sitelib}/magnum/tests

install -p -D -m 640 etc/magnum/magnum.conf.sample %{buildroot}/%{_sysconfdir}/magnum/magnum.conf
install -p -D -m 640 %{SOURCE20} %{buildroot}%{_datadir}/magnum/magnum-dist.conf

%description
Magnum provides Containers as a Service for OpenStack.

%package common
Summary: Heat common
Group: System Environment/Base

Requires: python-pbr
Requires: python-docker-py
Requires: python-oslo-concurrency
Requires: python-oslo-config
Requires: python-oslo-db
Requires: python-oslo-messaging
Requires: python-oslo-i18n
Requires: python-oslo-messaging
Requires: python-oslo-serialization
Requires: python-oslo-utils
Requires: python-oslo-versionedobjects
Requires: python-paramiko
Requires: python-pecan
Requires: python-keystonemiddleware
Requires: python-heatclient
Requires: python-keystoneclient
Requires: python-glanceclient
Requires: python-six
Requires: python-sqlalchemy
Requires: python-taskflow
Requires: python-jsonpatch
Requires: python-wsme
Requires: python-babel
Requires: MySQL-python

Requires(pre): shadow-utils

%description common
Components common to all OpenStack Heat services

%files common
%doc LICENSE
%{_bindir}/magnum-db-manage
%{_bindir}/magnum-template-manage
%{python_sitelib}/magnum*
%attr(-, root, magnum) %{_datadir}/magnum/magnum-dist.conf
%dir %attr(0750,magnum,root) %{_localstatedir}/log/magnum
%dir %attr(0755,magnum,root) %{_localstatedir}/run/magnum
%dir %attr(0755,magnum,root) %{_sharedstatedir}/magnum
%dir %attr(0755,magnum,root) %{_sysconfdir}/magnum
%config(noreplace) %{_sysconfdir}/logrotate.d/openstack-magnum
%config(noreplace) %attr(-, root, magnum) %{_sysconfdir}/magnum/magnum.conf

%pre common
getent group magnum >/dev/null || groupadd -r --gid 188 magnum
getent passwd magnum  >/dev/null || \
useradd --uid 188 -r -g magnum -d %{_sharedstatedir}/magnum -s /sbin/nologin \
-c "OpenStack Magnum Daemons" magnum
exit 0

%package conductor
Summary: The Openstack Magnum Conductor
Group: System Environment/Base

Requires: %{name}-common = %{version}-%{release}

%if 0%{?rhel} && 0%{?rhel} <= 6
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts
%else
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%endif

%description conductor
OpenStack Magnum Conductor process which executes API requests.

%files conductor
%doc README.rst LICENSE
%{_bindir}/magnum-conductor
%if 0%{?rhel} && 0%{?rhel} <= 6
%{_initrddir}/openstack-magnum-conductor
%else
%{_unitdir}/openstack-magnum-conductor.service
%endif

%post conductor
%if 0%{?rhel} && 0%{?rhel} <= 6
/sbin/chkconfig --add openstack-magnum-conductor
%else
%systemd_post openstack-magnum-conductor.service
%endif

%preun conductor
%if 0%{?rhel} && 0%{?rhel} <= 6
if [ $1 -eq 0 ]; then
    /sbin/service openstack-magnum-conductor stop >/dev/null 2>&1
    /sbin/chkconfig --del openstack-magnum-conductor
fi
%else
%systemd_preun openstack-magnum-conductor.service
%endif

%postun conductor
%if 0%{?rhel} && 0%{?rhel} <= 6
if [ $1 -ge 1 ]; then
    /sbin/service openstack-magnum-conductor condrestart >/dev/null 2>&1 || :
fi
%else
%systemd_postun_with_restart openstack-magnum-conductor.service
%endif


%package api
Summary: The Heat API
Group: System Environment/Base

Requires: %{name}-common = %{version}-%{release}

%if 0%{?rhel} && 0%{?rhel} <= 6
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts
%else
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%endif

%description api
OpenStack-native ReST API to the Heat Engine

%files api
%doc README.rst LICENSE
%{_bindir}/magnum-api
%if 0%{?rhel} && 0%{?rhel} <= 6
%{_initrddir}/openstack-magnum-api
%else
%{_unitdir}/openstack-magnum-api.service
%endif

%post api
%if 0%{?rhel} && 0%{?rhel} <= 6
/sbin/chkconfig --add openstack-magnum-api
%else
%systemd_post openstack-magnum-api.service
%endif

%preun api
%if 0%{?rhel} && 0%{?rhel} <= 6
if [ $1 -eq 0 ]; then
    /sbin/service openstack-magnum-api stop >/dev/null 2>&1
    /sbin/chkconfig --del openstack-magnum-api
fi
%else
%systemd_preun openstack-magnum-api.service
%endif

%postun api
%if 0%{?rhel} && 0%{?rhel} <= 6
if [ $1 -ge 1 ]; then
    /sbin/service openstack-magnum-api condrestart >/dev/null 2>&1 || :
fi
%else
%systemd_postun_with_restart openstack-magnum-api.service
%endif

%changelog
* Sun May 10 2015 Steven Dake <stdake@cisco.com> 2015.1.0-2
- Initial openstack-magnum package with backports to make it work

* Sat May 2 2015 Steven Dake <stdake@cisco.com> 2015.1.0-1
- Initial openstack-magnum package
